<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">

	<!-- External CSS -->
	<!-- <link rel="stylesheet" type="text/css" href="./index.css"> -->

	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
	<!-- End of Bootstrap CSS -->

	<title>Bootstrap Flex</title>
</head>
<body>
	<div class="container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex class to create a flex container & transform direct children into flex items.</p>

		<h2>Centering Elements</h2>
		<div style="height:500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column flex-column-reverse" >
		<!-- 
			d-flex will change all the child div elements into flex items will only occupy space enough for the element's content
		 -->
			<div class="h-25 p-3 bg-success">
				Flex Item A
			</div>
			<div class="h-25 p-3 bg-warning">
				Flex Item B
			</div>
			<div class="h-25 p-3 bg-danger">
				Flex Item C
			</div>
		</div>

		<h2>Flex Row</h2>
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="bg-success p-3">Flex Item A</div>
			<div class="bg-warning p-3">Flex Item B</div>
			<div class="bg-danger p-3">Flex Item C</div>
			
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="bg-success p-3">Flex Item A</div>
			<div class="bg-warning p-3">Flex Item B</div>
			<div class="bg-danger p-3">Flex Item C</div>
		</div>

		<h2>Creating SPace between our ELements</h2>
		<div class="bg-dark p-3 d-md-flex justify-content-around">
		<!-- d-md-flex will apply a flex value to the dispaly property na a "medium" size screen and larger -->
		<!-- Justify-content-around centers elements horizontally while creating space between elements & the border of its parent container -->
			<div class="p-3 bg-success col-md-2">Card A</div>
			<div class="p-3 bg-warning col-md-2">Card B</div>
			<div class="p-3 bg-danger col-md-2">Card C</div>
		</div>

		<h2>Flexbox w/ a Margin</h2>
		<div class="bg-dark p-3 d-flex">
			<!-- mr-auto class will occupy the remaining width of its parent container pushing all other elements -->
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
			<div class="p-3 bg-primary">Flex Item D</div>
		</div>

		<h2>Nested FLex Element</h2>
		<div class="p-3 bg-dark d-block d-md-flex">
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			
			<div class="w-50 d-block d-md-flex justify-content-between">
				<div class="p-3 bg-warning">Flex Item B</div>

				<div class="p-3 bg-danger">Flex Item C</div>

				<div class="p-3 bg-info">Flex Item D</div>
			</div>
			
		</div>

	</div>

	<!-- JS Dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
	<!-- End of JS Dependencies -->
</body>
</html>